/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Glue header included by Flick-generated stubs.
 * This file is named fluke.h to match CORBA module fluke.
 */

#ifndef _fluke_fluke_h
#define _fluke_fluke_h 1

#include <fluke/cp/rpc.h>
#include <flick/pres/mom.h>

static inline void
mom_set_exc(mom_exc_t *_ev, int _code)
{
	if (_code == 0)
		_ev->_type = exc_mom_no_exception;
	else {
		long *_cp = mom_flick_alloc (sizeof (long));
		if (_cp) {
			*_cp = _code;
			_ev->_type = exc_fluke_Error;
			_ev->_except = _cp;
		}
		else {
			_ev->_type = exc_mom_system_exception;
			_ev->_except = (void *) ENOMEM;
		}
	}
}

#endif
