/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * User-level control over the kernel instrumentation routines.
 */
#ifndef _FLUKE_INSTRUMENT_H_
#define _FLUKE_INSTRUMENT_H_

#include <oskit/compiler.h>

struct fluke_thread;

/*
 * Turn on instrumentation for specified thread.
 */
void fluke_instrument_thread(int op, struct fluke_thread *thread);

/*
 * Ugly "ops" to be passed in through the op field.  This
 * is an alternative to having N different syscalls, which
 * isn't fun to implement.
 */
#define INSTRUMENT_BEGIN  (0)
#define INSTRUMENT_END    (42)
#define INSTRUMENT_DUMP   (-1)
#define INSTRUMENT_EVENT1 (1)
#define INSTRUMENT_EVENT2 (2)
#define INSTRUMENT_EVENT3 (3)
			   
#include <fluke/machine/instrument.h>

#endif /* _FLUKE_INSTRUMENT_H_ */
