/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * XXX this shouldn't, generally, be included by itself, its just a first
 * pass and is included directly into <fluke/nest/server/server.h>--its
 * still quite intertwined with definitions in server.h
 */
#ifndef FLUKE_MOM_MOM_H
#define FLUKE_MOM_MOM_H

#include <fluke/mom/mom_exception.h>
#include <fluke/port.h>

/*
 * Mom object
 */
struct mom_soa_object
{
      fluke_port_t port;
      dispatcher_t dispatch;
};
typedef struct mom_soa_object mom_soa_object;
typedef struct mom_soa_object mom_soa_object_t;

/*
 * Mom object reference
 */


/*
 * Mom environment
 */
struct mom_soa_env
{
	int exception;
};
typedef struct mom_soa_env mom_soa_env;
typedef struct mom_soa_env mom_soa_env_t;

#define mom_set_exc(env, v) (env)->exception = (v)
#define mom_get_exc(env) ((env)->exception)

#endif
