/*
 * Copyright (c) 1995 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Machine-dependent definitions relating to the APIs of all Fluke objects.
 */
#ifndef _FLUKE_I386_OB_H_
#define _FLUKE_I386_OB_H_

/* User-memory sizes of all the Fluke object types,
   expressed as powers of two.  */
#define FLUKE_COND_SHIFT	3
#define FLUKE_MUTEX_SHIFT	3
#define FLUKE_PORT_SHIFT	3
#define FLUKE_PSET_SHIFT	3
#define FLUKE_REF_SHIFT		3
#define FLUKE_TASK_SHIFT	4
#define FLUKE_MAPPING_SHIFT	5
#define FLUKE_REGION_SHIFT	5
#define FLUKE_THREAD_SHIFT	7

#define FLUKE_MINOB_SHIFT	FLUKE_REF_SHIFT
#define FLUKE_MAXOB_SHIFT	FLUKE_THREAD_SHIFT

#endif /* _FLUKE_I386_OB_H_ */
