/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Machine-dependent signal definitions for the Fluke standalone C library
 */
#ifndef _FLUKE_X86_SAC_SIGNAL_H_
#define _FLUKE_X86_SAC_SIGNAL_H_

/*
 * Structure representing the state saved when the Fluke standalone C library
 * delivers a signal to an application signal handler.
 */
struct sigcontext
{
	unsigned eflags;
	unsigned eip;
	unsigned eax;
	unsigned ecx;
	unsigned edx;
	void *thread;
	unsigned code;
	unsigned subcode;
	unsigned edi;
	unsigned esi;
	unsigned ebx;
	unsigned gs;
	unsigned fs;
	unsigned ss;
	unsigned es;
	unsigned ds;
	unsigned cs;
	unsigned ebp;
	unsigned esp;
};

#endif /* _FLUKE_X86_SAC_SIGNAL_H_ */
