/*
 * Copyright (c) 1996, 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * This file simply contains a list of all the x86 Fluke API entrypoint names.
 * To use it, #define a macro e(name) and then #include this file;
 * the e(name) macro will then be expanded for each Fluke API entrypoint.
 *
 * Note that this file doesn't have multiple-include protection macros;
 * that way you can use this list more than once in the same source file.
 */

/*** Misc ***/
e(doprof)	/* XXX */
e(profil)
e(nop)
e(debug_dump_flob)
e(debug_puts)
e(debug_label_flob)
e(debug_dump_memuse)
e(debug_null_syscall)
e(debug_set_monregs)
e(instrument_thread)
/*e(memcpy)*/
/*e(memset)*/

/*** Thread ***/
e(thread_create_hash)
e(thread_destroy)
e(thread_set_state)
e(thread_get_state)
e(thread_enable_exceptions)
e(thread_disable_exceptions)
e(thread_interrupt)
e(thread_self)
e(thread_move)
e(thread_reference)
e(thread_get_saved_state)
e(thread_set_saved_state)
e(thread_return_from_exception)
e(thread_get_handlers)
e(thread_set_handlers)
e(thread_get_client)
e(thread_set_client)
e(thread_get_server)
e(thread_set_server)
e(thread_yield)
#if FLASK
e(thread_get_client_secure)
e(thread_set_client_secure)
e(thread_get_server_secure)
e(thread_set_server_secure)
#endif

/*** Task ***/
e(task_create_hash)
e(task_destroy)
e(task_set_state)
e(task_get_state)
e(task_move)
e(task_reference)

/*** Region ***/
e(region_create_hash)
e(region_destroy)
e(region_set_state)
e(region_get_state)
e(region_move)
e(region_reference)
e(region_protect)
e(region_search)

/*** Mapping ***/
e(mapping_create_hash)
e(mapping_destroy)
e(mapping_set_state)
e(mapping_get_state)
e(mapping_move)
e(mapping_protect)

/*** Port ***/
e(port_create_hash)
e(port_destroy)
e(port_set_state)
e(port_get_state)
e(port_move)
e(port_reference)

/*** Port Set ***/
e(pset_create_hash)
e(pset_destroy)
e(pset_set_state)
e(pset_get_state)
e(pset_move)
e(pset_reference)

/*** Mutex ***/
e(mutex_create_hash)
e(mutex_destroy)
e(mutex_get_state)
e(mutex_set_state)
e(mutex_lock)
e(mutex_unlock)
e(mutex_trylock)
e(mutex_move)
e(mutex_reference)

/*** Cond ***/
e(cond_create_hash)
e(cond_destroy)
e(cond_get_state)
e(cond_set_state)
e(cond_wait)
e(cond_signal)
e(cond_broadcast)
e(cond_move)
e(cond_reference)

/*** IPC ***/
e(ipc_send)
#if FLASK
e(ipc_send_secure)
#endif
e(ipc_call)
#if FLASK
e(ipc_call_secure)
#endif
e(ipc_reply)
e(ipc_reply_wait_receive)
#if FLASK
e(ipc_reply_wait_receive_secure)
#endif
e(ipc_setup)
e(ipc_wait_receive)
#if FLASK
e(ipc_wait_receive_secure)
#endif
e(ipc_client_connect_send)
#if FLASK
e(ipc_client_connect_send_secure)
#endif
e(ipc_client_ack_send)
e(ipc_client_send)
e(ipc_client_connect_send_over_receive)
#if FLASK
e(ipc_client_connect_send_over_receive_secure)
#endif
e(ipc_client_ack_send_over_receive)
e(ipc_client_send_over_receive)
e(ipc_client_receive)
e(ipc_client_disconnect)
e(ipc_server_ack_send)
e(ipc_server_send)
e(ipc_server_ack_send_wait_receive)
#if FLASK
e(ipc_server_ack_send_wait_receive_secure)
#endif
e(ipc_server_ack_send_over_receive)
e(ipc_server_send_wait_receive)
#if FLASK
e(ipc_server_send_wait_receive_secure)
#endif
e(ipc_server_send_over_receive)
e(ipc_server_receive)
e(ipc_server_disconnect)

/*** Ref ***/
e(ref_create)
e(ref_destroy)
e(ref_move)
e(ref_check)
e(ref_compare)
e(ref_copy)
e(ref_type)
e(ref_hash)
#if FLASK
e(ref_sid)
e(security_reference)
#endif
