/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Fluke page fault handling.
 */
#ifndef _KERNEL_FAULT_H_
#define _KERNEL_FAULT_H_

#include <fluke/vm.h>

struct s_thread;
struct s_task;
struct s_region;
struct fragment;

int task_fault(struct s_thread *fthread, struct s_task *ftask,
	       oskit_addr_t fva, fluke_prot_t fprot, struct fragment **fragp,
	       struct s_region **regionp, oskit_addr_t *regoffp);
int task_lookup(struct s_thread *fthread, struct s_task *ftask,
		oskit_addr_t fva, fluke_prot_t fprot, struct fragment **fragp);

#endif /* _KERNEL_FAULT_H_ */
