/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Simple tree data structure.
 * It dosen't make error checking of any time.
 * It assumes correct use and infinite memory.
 */


#include "list_static.h"

#ifndef _FLUKE_KERNEL_LIST_H_
#define _FLUKE_KERNEL_LIST_H_


void list_create(list_t *l);

void list_destroy(list_t *l);

/* Places window at begining of list */
void list_go_first(list_t *l);

/* Returns 1 when window is at the end of the list */
int list_end(list_t *l);

/* Returns 1 when the list is empty */
int list_empty( list_t *l);

unsigned list_size(list_t *l);

/* Moves the window forward one elemente */
void list_next(list_t *l);

/* Gets element where the window is placed */
void *list_get(list_t *l);

/* Inserts element before  the window */
void list_insert(list_t *l, void *e);

/* The windows moves to the next element in the list */
void list_remove(list_t *l);

/* Returns 1 is successful. Window left on the element */
int list_find(list_t *l, void *e);

/* Returns 1 is successful. Window left on the next element */
int list_find_remove(list_t *l, void *e);

#endif

