/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * This file provides common subroutines for PCLSRing threads
 * in optimized user entry point code.
 */

#include "config_opt_threads.h"
#include "config_opt_synch.h"
#include "config_opt_ref.h"

#if defined CONFIG_OPT_THREADS || \
    defined CONFIG_OPT_SYNCH || \
    defined CONFIG_OPT_REF

#include "s_thread.h"
#include "exception.h"
#include <fluke/machine/syscall.h>

/*
 * Fix up the thread by making it return as if the system call finished;
 * its current register values are fine as syscall return values.
 */
void
pclsr_success(struct s_thread *sth)
{
	EXC_SET_IP(sth, fluke_nop__entry);
}

#endif
