/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#define PMCOUNT		/* XXX */

#ifdef PMCOUNT

#ifndef ASSEMBLER
#include <oskit/machine/proc_reg.h>

/* XXX should be in proc_reg.h? */

/* XXX low 32 bits only */
#define get_pmc(reg) \
({ \
	register unsigned int _temp__; \
	asm volatile ("	rdpmc" \
		: "=a" (_temp__) : "c" (reg) : "eax", "ecx", "edx"); \
		_temp__; \
})

/* XXX low 32 bits only */
#define set_msr(r, v) { \
	asm volatile (" xorl %%edx,%%edx; wrmsr" \
		: : "c" (r), "a" (v) : "eax", "ecx", "edx"); }

/* event selection registers */
#define PMR_SEL0	0x186
#define PMR_SEL1	0x187

#define PMR_SELINT	0x100000	/* enable APIC int on overflow */
#define PMR_SELEN	0x400000	/* enable counters (sel0 only) */

/* event counter registers */
#define PMR_CNT0	0xC1
#define PMR_CNT1	0xC2

#endif
#endif
