/*
 * Copyright (c) 1997 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_KERNEL_ROUND_ROBIN_H_
#define _FLUKE_KERNEL_ROUND_ROBIN_H_

#include "prio_queue.h"

/*
 * 0 == high priority == interrupt thread
 * 1 == normal priority == normal threads
 * 2 == low priority == idle thread
 *
 * We use queue[0]'s lock to lock all the queues.
 */
#define NQUEUES 3
#define SCHED_PRIINTR	0
#define SCHED_PRIUSER	1
#define SCHED_PRIIDLE	2

struct sched_state {
	struct prio_queue_node link;

	/* Fixed priority (queue #). */
	int			pri;
};
typedef struct sched_state sched_state_t;

#define SCHED_LINK_TO_THREAD(l) \
	((struct s_thread *)((oskit_addr_t)(l) - \
		(oskit_addr_t)&((struct s_thread *)0)->sched_state.link))

#endif /* _FLUKE_KERNEL_ROUND_ROBIN_H_ */
