/*
 * Copyright (c) 1996 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Optimized version of atomic counters for the x86.
 * Non-inlined version.
 */

#include "acount.h"
#include "debug.h"

#if defined(CONFIG_OPT_ACOUNT) && !defined(CONFIG_INLINING)

void
acount_init(struct acount *ac, int value)
{
	_acount_init(ac, value);
}

int
acount_incr(struct acount *ac)
{
	return _acount_incr(ac);
}

int
acount_decr(struct acount *ac)
{
	return _acount_decr(ac);
}
#endif
