/*
 * Copyright (c) 1995 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

#ifndef _FLUKE_KERNEL_X86_DEBUG_H_
#define _FLUKE_KERNEL_X86_DEBUG_H_

#ifndef ASSEMBLER

#include_next "debug.h"

#include "config_kstackcheck.h"

#ifdef CONFIG_KSTACKCHECK
#include "s_thread.h"
#ifdef DEBUG
#undef assert
#define assert(v) {							\
	((void)(!(v) ? (panic("%s:%d: failed assertion `"#v"'\n",	\
			__FILE__, __LINE__), 0) : 0));			\
	KSTACK_CHECK(current_thread());					\
}
#endif
#endif

#else /* ASSEMBLER */

#include <oskit/x86/debug.h>

/*
 * When debugging is enabled, clear ebp on entry into the kernel
 * so that kernel stack backtraces will terminate cleanly.
 */
#ifdef DEBUG
#define CLEAR_EBP	xorl	%ebp,%ebp
#else
#define CLEAR_EBP
#endif

#endif /* ASSEMBLER */

#endif /* _FLUKE_KERNEL_X86_DEBUG_H_ */
