/*
 * Copyright (c) 1998 The University of Utah and the Flux Group.
 * All rights reserved.
 * 
 * This file is part of the Fluke Operating System.  The Fluke Operating System
 * is free software, also known as "open source;" you can redistribute it
 * and/or modify it under the terms of the GNU General Public License (GPL),
 * version 2, as published by the Free Software Foundation (FSF).  To explore
 * alternate licensing terms, contact the University of Utah at
 * csl-dist@cs.utah.edu or +1-801-585-3271.
 * 
 * The Fluke Operating System is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GPL for more
 * details.  You should have received a copy of the GPL along with the Fluke
 * Operating System; see the file COPYING.  If not, write to the FSF, 59 Temple
 * Place #330, Boston, MA 02111-1307, USA.
 */

/*
 * Optimized user-space fluke_ref_t operations.
 */

#include <oskit/x86/asm.h>

#include "x86.h"
#include "idt.h"
#include <fluke/x86/syscall.h>

#define UENTRY_KPAGE	EXT(u_ref_page)
#define UENTRY_UPAGE	0x04002000
#include "u_entry.h"

	.text

	P2ALIGN(12)

	.globl	EXT(u_ref_page)
LEXT(u_ref_page)

/* 0x000 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_send)
#if FLASK
FLUKE_ENTRY(sys_ipc_send_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x100 */
FLUKE_ENTRY(sys_ipc_call)
#if FLASK
FLUKE_ENTRY(sys_ipc_call_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_reply)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_reply_wait_receive)
#if FLASK
FLUKE_ENTRY(sys_ipc_reply_wait_receive_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_ipc_client_connect_send)
#if FLASK
FLUKE_ENTRY(sys_ipc_client_connect_send_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif

/* 0x200 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_client_disconnect)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x300 */
FLUKE_ENTRY(sys_ipc_client_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_client_send)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x400 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_client_ack_send_over_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_client_send_over_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x500 */
FLUKE_ENTRY(sys_ipc_client_connect_send_over_receive)
FLUKE_ENTRY(sys_invalid)
#if FLASK
FLUKE_ENTRY(sys_ipc_client_connect_send_over_receive_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_client_ack_send)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x600 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x700 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x800 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0x900 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_wait_receive)
FLUKE_ENTRY(sys_invalid)

/* 0xa00 */
#if FLASK
FLUKE_ENTRY(sys_ipc_wait_receive_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_disconnect)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0xb00 */
FLUKE_ENTRY(sys_ipc_server_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_send)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0xc00 */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_ack_send_over_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_send_over_receive)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_send_wait_receive)
FLUKE_ENTRY(sys_invalid)
#if FLASK
FLUKE_ENTRY(sys_ipc_server_send_wait_receive_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)

/* 0xd00 */
FLUKE_ENTRY(sys_ipc_server_ack_send_wait_receive)
#if FLASK
FLUKE_ENTRY(sys_ipc_server_ack_send_wait_receive_secure)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_server_ack_send)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0xe00 */
FLUKE_ENTRY(sys_invalid) /* empty (valid) syscall ifndef CONFIG_INSTRUMENT */
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
#if FLASK
FLUKE_ENTRY(sys_security_reference)
#else
FLUKE_ENTRY(sys_invalid)
#endif
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ipc_setup)
FLUKE_ENTRY(sys_invalid)

/* 0xf00 */
FLUKE_ENTRY(sys_ref_create)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_ref_destroy)
FLUKE_ENTRY(sys_invalid)
FLUKE_ENTRY(sys_invalid)

/* 0xf60 */
BEGIN_UENTRY(u_ref_hash)
	movl U_REF_HASH(%fluke_ref_hash__ref), %fluke_ref_hash__result_hash
	ret
#define pclsr_u_ref_hash	pclsr_success
END_UENTRY(u_ref_hash, 0x10)

/* 0xf70 */
#if FLASK
FLUKE_ENTRY(sys_ref_sid)
#else
FLUKE_ENTRY(sys_invalid)
#endif

/* 0xf80 */
BEGIN_UENTRY(u_ref_type)
	movl U_REF_HANDLE(%eax), %eax
	andl $0xf, %eax
	ret
END_UENTRY(u_ref_type, 0x10)

/* 0xf90 */
FLUKE_ENTRY(sys_ref_check)
FLUKE_ENTRY(sys_invalid)

/* 0xfb0 */
BEGIN_UENTRY(u_ref_compare)
	movl U_REF_HANDLE(%fluke_ref_compare__ref1), %ecx
u_ref_compare_cmpl:
	cmpl %ecx, U_REF_HANDLE(%fluke_ref_compare__ref2)
ANNO_UENTRY(u_ref_compare)
	sete %al
	movzbl %al, %eax
	ret
ANNO_UENTRY(u_ref_compare_cmpl)
9:	.space 0x10-(9b-u_ref_compare)

FLUKE_ENTRY(sys_ref_copy)
FLUKE_ENTRY(sys_ref_move)
FLUKE_ENTRY(sys_invalid) /* 0xfe0: Kernel private, not in the Fluke API */

/* 0xff0: sys_invalid (special) */
	ret
	.byte	0
	.short	0,0,0,0,0
	.long	EXT(sys_invalid)
